#include <Windows.h>
#include <stdio.h>

DWORD WINAPI thread_function(LPVOID arg);
WCHAR message[] = L"Hello I'm a Thread";
DWORD thread_finished = 0;

int wmain() 
{
	int count=0;
	HANDLE a_thread;

	wprintf(L"The main() process ID is %u\n", GetCurrentProcessId());
	wprintf(L"The main() thread ID is %u\n", GetCurrentThreadId());
	wprintf(L"\n");
	
	// Create a new thread.
	a_thread = CreateThread(NULL, 0, thread_function, (LPVOID)message, 0, NULL);

	if (a_thread == NULL)
	{
		wprintf(L"CreateThread() - Thread creation failed, error %u\n", GetLastError());
		exit(EXIT_FAILURE);
	}
	else
		wprintf(L"CreateThread() is OK!\n");

	if (!SetThreadPriority(a_thread, THREAD_PRIORITY_LOWEST))
	{
		wprintf(L"SetThreadPriority(..., THREAD_PRIORITY_LOWEST) - Setting schedule priority failed, error %u\n", GetLastError());
		exit(EXIT_FAILURE);
	}
	else
		wprintf(L"SetThreadPriority(...,THREAD_PRIORITY_LOWEST) is OK!\n");
	
	if(CloseHandle(a_thread) != 0)
		wprintf(L"a_thread handle was successfully closed!\n");
	else
		wprintf(L"Failed to close a_thread handle, error %u\n", GetLastError());

	while(!thread_finished)
	{
		wprintf(L"Waiting for thread to finished count %d\n", ++count);
		Sleep(1000);
	}
	
	wprintf(L"Well, the other thread finished, bye!\n");
	exit(EXIT_SUCCESS);
}

DWORD WINAPI thread_function(LPVOID arg)
{
	wprintf(L"thread_function() is running. Arg received was %s, thread ID is %u\n", arg, GetCurrentThreadId());
	Sleep(4000);
	wprintf(L"Second thread, ID %u setting finished flag, and exiting now...\n", GetCurrentThreadId());
	thread_finished = 1;
	return 100;
}